<template>
  <!--The Header shows an Appbar that displays the PhysioForm Logo, the name of the Page,
      symbols to print and export the formular and mdi-dots for the imprint and for the data protection. -->
  <v-app-bar color="primary" dark>
    <router-link aria-label="Link zu Homepage" :to="{ name: 'Home' }">
      <v-img
              alt="Physioform Logo"
              class="mx-2"
              src="../assets/logo.svg"
              max-width="40"
              contain
      >
      </v-img>
    </router-link>

    <v-spacer></v-spacer>

    <router-link :to="{ name: 'Home' }">
      <v-toolbar-title>PhysioForm</v-toolbar-title>
    </router-link>

    <v-spacer></v-spacer>

    <div class="appheader-icon" title="Herunterladen">
      <v-dialog
              v-if="
          $vuetify.breakpoint.smAndUp && $router.currentRoute.fullPath === '/'
        "
              v-model="dialogDownload"
              persistent
              max-width="600px"
      >
        <template v-slot:activator="{ on, attrs }">
          <v-btn dark v-bind="attrs" v-on="on" icon aria-label="Herunterladen">
            <v-icon>mdi-cloud-download</v-icon>
          </v-btn>
        </template>
        <DownloadModal @closeDialogDownload="closeDialogDownload()"/>
      </v-dialog>
    </div>

    <!-- Here are the mdi-dots to show the imprint and the data protection in a list. -->
    <v-menu left bottom>
      <template v-slot:activator="{ on }">
        <v-btn aria-label="Andere optionen" icon v-on="on">
          <v-icon>mdi-dots-vertical</v-icon>
        </v-btn>
      </template>
      <v-list>
        <v-list-item>
          <v-btn block color="white" tile depressed @click="() => {}">
            <router-link class="options-link" :to="{ name: 'Privacy' }">
              <v-list-item-title>Datenschutzerklärung</v-list-item-title>
            </router-link>
          </v-btn>
        </v-list-item>

        <v-list-item>
          <v-btn block color="white" tile depressed @click="() => {}">
            <router-link class="options-link" :to="{ name: 'Impressum' }">
              <v-list-item-title>Impressum</v-list-item-title>
            </router-link>
          </v-btn>
        </v-list-item>

        <v-divider></v-divider>

        <v-list-item>
          <v-btn block color="white" tile depressed @click="downloadJSON()">
            <v-list-item-title>Export JSON</v-list-item-title>
          </v-btn>
        </v-list-item>

        <v-list-item>
          <v-btn block color="white" tile depressed @click="downloadPDF()">
            <v-list-item-title>Export PDF</v-list-item-title>
          </v-btn>
        </v-list-item>

        <v-divider></v-divider>

        <v-list-item>
          <v-dialog
                  v-model="dialogUpload"
                  persistent
                  max-width="600px"
          >
            <template v-slot:activator="{ on, attrs }">
              <v-btn block aria-label="JSON Importieren" v-bind="attrs" v-on="on" color="white" tile depressed>
                <v-list-item-title>Import JSON</v-list-item-title>
              </v-btn>
            </template>
            <JsonUploadModal @closeDialogUpload="closeDialogUpload()"/>
          </v-dialog>
        </v-list-item>

      </v-list>
    </v-menu>
  </v-app-bar>
</template>

<script>
  import DownloadModal from "./DownloadModal";
  import JsonUploadModal from "./JsonUploadModal";
  //The export uses a Question component.
  export default {
    name: "Question",
    components: {
      DownloadModal,
      JsonUploadModal
    },
    data() {
      return {
        dialogDownload: false,
        dialogUpload: false
      };
    },
    methods: {
      downloadJSON() {
        this.$store.dispatch("downloadJSON");
      },
      downloadPDF() {
        this.$store.dispatch("downloadPDF");
      },
      closeDialogDownload() {
        this.dialogDownload = false;
      },
      closeDialogUpload() {
        this.dialogUpload = false;
      }
    }
  };
</script>

<style scoped>
  .v-toolbar__title {
    color: white;
  }

  .options-link {
    text-decoration: none;
    color: #000000dd;
  }

  .appheader-icon {
    min-width: 48px;
  }
</style>
